/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the config-2014-11-12.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Net;
using System.Text;
using System.Xml.Serialization;

using Amazon.ConfigService.Model;
using Amazon.Runtime;
using Amazon.Runtime.Internal;
using Amazon.Runtime.Internal.Transform;
using Amazon.Runtime.Internal.Util;
using ThirdParty.Json.LitJson;

namespace Amazon.ConfigService.Model.Internal.MarshallTransformations
{
    /// <summary>
    /// Response Unmarshaller for DeliveryChannelStatus Object
    /// </summary>  
    public class DeliveryChannelStatusUnmarshaller : IUnmarshaller<DeliveryChannelStatus, XmlUnmarshallerContext>, IUnmarshaller<DeliveryChannelStatus, JsonUnmarshallerContext>
    {
        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        DeliveryChannelStatus IUnmarshaller<DeliveryChannelStatus, XmlUnmarshallerContext>.Unmarshall(XmlUnmarshallerContext context)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Unmarshaller the response from the service to the response class.
        /// </summary>  
        /// <param name="context"></param>
        /// <returns></returns>
        public DeliveryChannelStatus Unmarshall(JsonUnmarshallerContext context)
        {
            context.Read();
            if (context.CurrentTokenType == JsonToken.Null) 
                return null;

            DeliveryChannelStatus unmarshalledObject = new DeliveryChannelStatus();
        
            int targetDepth = context.CurrentDepth;
            while (context.ReadAtDepth(targetDepth))
            {
                if (context.TestExpression("configHistoryDeliveryInfo", targetDepth))
                {
                    var unmarshaller = ConfigExportDeliveryInfoUnmarshaller.Instance;
                    unmarshalledObject.ConfigHistoryDeliveryInfo = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("configSnapshotDeliveryInfo", targetDepth))
                {
                    var unmarshaller = ConfigExportDeliveryInfoUnmarshaller.Instance;
                    unmarshalledObject.ConfigSnapshotDeliveryInfo = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("configStreamDeliveryInfo", targetDepth))
                {
                    var unmarshaller = ConfigStreamDeliveryInfoUnmarshaller.Instance;
                    unmarshalledObject.ConfigStreamDeliveryInfo = unmarshaller.Unmarshall(context);
                    continue;
                }
                if (context.TestExpression("name", targetDepth))
                {
                    var unmarshaller = StringUnmarshaller.Instance;
                    unmarshalledObject.Name = unmarshaller.Unmarshall(context);
                    continue;
                }
            }
          
            return unmarshalledObject;
        }


        private static DeliveryChannelStatusUnmarshaller _instance = new DeliveryChannelStatusUnmarshaller();        

        /// <summary>
        /// Gets the singleton.
        /// </summary>  
        public static DeliveryChannelStatusUnmarshaller Instance
        {
            get
            {
                return _instance;
            }
        }
    }
}